/*#######################################################################################

Copyright (C) 2013 Leo-Andres Hofmann
www.leo-andres.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

#######################################################################################*/

#include <avr/io.h>

#include "ports.h"

//Initialisiert alle I/O-Ports
//Nach dem Init sind alle Funktionen deaktiviert
void ports_init(void)
{

/*----------------------------------------------------------------------------------------*/
	//Unbenutze Pins & Ports (Pullups aktivieren)

	FREE_1_PORT |= (FREE_1_PINS);

/*----------------------------------------------------------------------------------------*/
	//Bus

	//TWI
	DDR(TWI_PORT) &= ~(1<<TWI_SDA_PIN); 
	DDR(TWI_PORT) &= ~(1<<TWI_SCL_PIN); 

	//ISP-Master inkl. Reset
	//Pin-Richtung wird vom Programmiersystem umgeschaltet!
	DDR(ISP_PORT) &= ~(1<<ISP_MISO_PIN); 	
	ISP_PORT &= ~(1<<ISP_MISO_PIN);

	DDR(ISP_PORT) &= ~(1<<ISP_MOSI_PIN); 	
	ISP_PORT &= ~(1<<ISP_MOSI_PIN);

	DDR(ISP_PORT) &= ~(1<<ISP_SCK_PIN); 	
	ISP_PORT &= ~(1<<ISP_SCK_PIN);

	DDR(ISP_PORT) &= ~(1<<ISP_RESET_PIN); 	
	ISP_PORT &= ~(1<<ISP_RESET_PIN);

/*----------------------------------------------------------------------------------------*/
	//Eingnge, keine Pullups

	DDR(UART_DTR_PORT) &= ~(1<<UART_DTR_PIN); 	
	UART_DTR_PORT &= ~(1<<UART_DTR_PIN);

/*----------------------------------------------------------------------------------------*/
	//Eingnge, aktive Pullups

	DDR(SW_UART_PORT) &= ~(1<<SW_UART_PIN); 	
	SW_UART_PORT |= (1<<SW_UART_PIN);

	DDR(SW_RESET_PORT) &= ~(1<<SW_RESET_PIN); 	
	SW_RESET_PORT |= (1<<SW_RESET_PIN);

/*----------------------------------------------------------------------------------------*/
	//Ausgangszustnde herstellen (alles aus)

	UART_Disable;
	Clock_Off;

	LED_Fault_Off;
	LED_UART_Off;
	LED_Status_Off;

/*----------------------------------------------------------------------------------------*/
	//Ausgnge

	DDR(CLK_PORT) |= (1<<CLK_PIN);

	//UART
	DDR(UART_EN_PORT) |= (1<<UART_EN_PIN);
	DDR(UART_SEL_PORT) |= (1<<UART_SEL_PIN);

	//LEDs
	DDR(LED_FAULT_PORT) |= (1<<LED_FAULT_PIN);

	DDR(LED_UART_PORT) |= (1<<LED_UART_STK_PIN);
	DDR(LED_UART_PORT) |= (1<<LED_UART_MCU_PIN);

	DDR(LED_STAT_PORT) |= (1<<LED_STAT_RED_PIN);
	DDR(LED_STAT_PORT) |= (1<<LED_STAT_GREEN_PIN);
}

