/*#######################################################################################

bertragungsprotokoll fr das Programmiersystem

Quelle: AVR068, www.atmel.com

Copyright (C) 2013 Leo-Andres Hofmann
www.leo-andres.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

#######################################################################################*/

#ifndef _STK500PROTOCOL_H_
	#define _STK500_PROTOCOL_H_

////////////////////////////////////////////////////////////////////////////////////////////
//Frame-Aufbau

#define STK_FRM_START					0x1B
#define STK_FRM_TOKEN					0x0E

////////////////////////////////////////////////////////////////////////////////////////////
//Statuscodes

#define STK_STAT_CMD_OK					0x00

#define STK_STAT_CMD_TOUT				0x80
#define STK_STAT_RDY_BSY_TOUT			0x81

#define STK_STAT_CMD_FAILED				0xC0
#define STK_STAT_CMD_CHECKSUM_ERROR		0xC1
#define STK_STAT_CMD_UNKNOWN			0xC9

//Spezielle Kommando-ID fr Prfsummenfehler
#define STK_ANSW_CHECKSUM_ERROR			0xB0

////////////////////////////////////////////////////////////////////////////////////////////
//Parameter

#define STK_PARAM_BUILD_NUMBER_LOW		0x80
#define STK_PARAM_BUILD_NUMBER_HIGH		0x81
#define STK_PARAM_HW_VER				0x90
#define STK_PARAM_SW_MAJOR				0x91
#define STK_PARAM_SW_MINOR				0x92
#define STK_PARAM_VTARGET				0x94
#define STK_PARAM_VADJUST				0x95
#define STK_PARAM_OSC_PSCALE			0x96
#define STK_PARAM_OSC_CMATCH			0x97
#define STK_PARAM_SCK_DURATION			0x98
#define STK_PARAM_TOPCARD_DETECT		0x9A
//#define STK_PARAM_STATUS				0x9C
#define STK_PARAM_DATA					0x9D
#define STK_PARAM_RESET_POLARITY		0x9E
#define STK_PARAM_CONTROLLER_INIT		0x9F

////////////////////////////////////////////////////////////////////////////////////////////
//Programmierkommandos

#define STK_CMD_ENTER_PROGMODE_ISP		0x10
#define STK_CMD_LEAVE_PROGMODE_ISP		0x11
#define STK_CMD_CHIP_ERASE_ISP			0x12
#define STK_CMD_PROGRAM_FLASH_ISP		0x13
#define STK_CMD_READ_FLASH_ISP			0x14
#define STK_CMD_PROGRAM_EEPROM_ISP		0x15
#define STK_CMD_READ_EEPROM_ISP			0x16
#define STK_CMD_PROGRAM_FUSE_ISP		0x17
#define STK_CMD_READ_FUSE_ISP			0x18
#define STK_CMD_PROGRAM_LOCK_ISP		0x19
#define STK_CMD_READ_LOCK_ISP			0x1A
#define STK_CMD_READ_SIGNATURE_ISP		0x1B
#define STK_CMD_READ_OSCCAL_ISP			0x1C
#define STK_CMD_SPI_MULTI				0x1D

////////////////////////////////////////////////////////////////////////////////////////////
//Allgemeine Kommandos

#define STK_CMD_SIGN_ON					0x01
#define STK_CMD_SET_PARAM				0x02
#define STK_CMD_GET_PARAM				0x03
//#define STK_CMD_SET_DEV_PARAM			0x04
//#define STK_CMD_OSCCAL					0x05
#define STK_CMD_LOAD_ADDR				0x06
#define STK_CMD_FW_UPGRADE				0x07

#endif //_STK500_PROTOCOL_H_
