/*#######################################################################################

Hilfsfuntkionen fr das Programmiersystem

Copyright (C) 2013 Leo-Andres Hofmann
www.leo-andres.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

#######################################################################################*/

#ifndef _STK500_TOOLS_H_
	#define _STK500_TOOLS_H_

////////////////////////////////////////////////////////////////////////////////////////////
//Register & Steuermakros

#define STK_ISP_DATA		SPDR
#define STK_ISP_WAIT_DATA	!(SPSR & (1<<SPIF))

#define STK_ISP_ENABLE		SPCR = (1<<SPE) | (1<<MSTR);
#define STK_ISP_DISABLE		SPCR = 0x00;
#define STK_ISP_SUSPEND		SPCR &= ~(1<<SPE);
#define STK_ISP_RESUME		SPCR |= (1<<SPE);

//Taktrate
#define STK_ISP_CLK_0		{SPCR |= (1<<SPR0); SPSR |= (1<<SPI2X);}				//1,843MHz
#define STK_ISP_CLK_1		{SPCR |= (1<<SPR1); SPSR |= (1<<SPI2X);}				//460,8kHz
#define STK_ISP_CLK_2		{SPCR |= (1<<SPR1) | (1<<SPR0); SPSR &= ~(1<<SPI2X);}	//115,2kHz

////////////////////////////////////////////////////////////////////////////////////////////
//Funktionen

//ISP-bertragung
extern void stkT_ISP_setClkDuration(uint8_t duration);
extern uint8_t stkT_ISP_getClkDuration(void);

//Liefert jeweils das letzte empfangene Byte zurck
extern uint8_t stkT_ISP_transfer_8(uint8_t data);
extern uint8_t stkT_ISP_transfer_16(uint16_t data);
extern uint8_t stkT_ISP_transfer_32(uint32_t data);

extern void stkT_ISP_clockPulse(void);

extern uint8_t stkT_ISP_TestRDYBSY(uint16_t cycles);

//Datenports reservieren & freigeben, Reset-Puls
extern void stkT_ISP_assign(void);
extern void stkT_ISP_release(void);
extern void stkT_ISP_tgRun(void);
extern void stkT_ISP_tgForceRun(void);
extern void stkT_ISP_tgStop(void);
extern void stkT_ISP_tgResetPulse(void);

#endif //_STK500_TOOLS_H_
